package digi.recipeManager;

import net.milkbowl.vault.Vault;
import net.milkbowl.vault.economy.Economy;

import org.bukkit.plugin.RegisteredServiceProvider;

import com.iCo6.iConomy;
import com.iCo6.system.Accounts;
import com.nijikokun.register.Register;
import com.nijikokun.register.payment.*;

public class Econ
{
	private static Economy vaultEcon;
	private static Method registerEcon;
	private static Accounts iConomyEcon;
	public static boolean enabled = false;
	
	public Econ()
	{
		if(Main.pm.getPlugin("Vault") instanceof Vault)
		{
			final RegisteredServiceProvider<Economy> service = Main.sv.getServicesManager().getRegistration(net.milkbowl.vault.economy.Economy.class);
			
			if(service != null)
			{
				vaultEcon = service.getProvider();
				
				if(vaultEcon != null)
					Main.log.fine("Vault detected and connected, economy available.");
			}
		}
		else if(Main.pm.getPlugin("Register") instanceof Register)
		{
			registerEcon = Methods.getMethod();
			
			if(registerEcon != null)
				Main.log.fine("Register detected and connected, economy available.");
		}
		else if(Main.pm.getPlugin("iConomy") instanceof iConomy)
		{
			iConomyEcon = new Accounts();
			
			if(iConomyEcon != null)
				Main.log.fine("iConomy detected and connected, economy available.");
		}
		
		enabled = (vaultEcon != null || registerEcon != null || iConomyEcon != null);
	}
	
	public static String moneyFormat(final double amount)
	{
		if(!enabled)
			return null;
		
		if(vaultEcon != null)
			return vaultEcon.format(amount);
		else if(registerEcon != null)
			return registerEcon.format(amount);
		else if(iConomyEcon != null)
			return iConomy.format(amount);
		else
			return null;
	}
	
	public static double moneyAmount(final String playerName)
	{
		if(!enabled)
			return 0;
		
		if(vaultEcon != null)
			return vaultEcon.getBalance(playerName);
		else if(registerEcon != null)
			return registerEcon.getAccount(playerName).balance();
		else if(iConomyEcon != null)
			return iConomyEcon.get(playerName).getHoldings().getBalance();
		else
			return 0;
	}
	
	public static void moneyAdd(final String playerName, final double amount)
	{
		if(!enabled)
			return;
		
		if(vaultEcon != null)
			vaultEcon.depositPlayer(playerName, amount);
		else if(registerEcon != null)
			registerEcon.getAccount(playerName).add(amount);
		else if(iConomyEcon != null)
			iConomyEcon.get(playerName).getHoldings().add(amount);
	}
	
	public static void moneySubtract(final String playerName, final double amount)
	{
		if(!enabled)
			return;
		
		if(vaultEcon != null)
			vaultEcon.withdrawPlayer(playerName, amount);
		else if(registerEcon != null)
			registerEcon.getAccount(playerName).subtract(amount);
		else if(iConomyEcon != null)
			iConomyEcon.get(playerName).getHoldings().subtract(amount);
	}
}
