package digi.recipeManager.data;

import java.util.*;
import java.util.Map.Entry;

import org.bukkit.ChatColor;

public class Craft extends Recipe
{
	public ItemData[] ingredients;
	public Item[] leftovers;
	public List<Item> results;
	
	public Craft(final ItemData[] ingredients, final Item[] leftovers, final List<Item> results, final Recipe recipeData)
	{
		super(recipeData);
		this.ingredients = ingredients;
		this.leftovers = leftovers;
		this.results = results;
	}
	
	public Item getRandomResult()
	{
		final int rand = new Random().nextInt(100);
		int chance = 0;
		Item result = null;
		
		for(final Item item : results)
		{
			if((chance += item.chance) > rand)
			{
				result = item;
				break;
			}
		}
		
		return result;
	}
	
	@Override
	public String[] print()
	{
		final String[] slots = new String[9];
		final List<String> str = new ArrayList<String>();
		final HashMap<String, Character> charItems = new HashMap<String, Character>();
		char charIndex = 'a';
		Character charStr;
		
		for(int i = 0; i < 9; i++)
		{
			if(ingredients[i] == null)
				slots[i] = ChatColor.GRAY + "[" + ChatColor.BLACK + "_" + ChatColor.GRAY + "]";
			else
			{
				charStr = charItems.get(ingredients[i].printItemData());
				
				if(charStr == null)
				{
					charItems.put(ingredients[i].printItemData(), charIndex);
					charStr = charIndex;
					charIndex++;
				}
				
				slots[i] = ChatColor.GRAY + "[" + ChatColor.BLUE + charStr + ChatColor.GRAY + "]";
			}
		}
		
		str.add(ChatColor.GOLD + "" + ChatColor.UNDERLINE + "Workbench shaped recipe:");
		str.add(slots[0] + slots[1] + slots[2]);
		str.add(slots[3] + slots[4] + slots[5]);
		str.add(slots[6] + slots[7] + slots[8]);
		
		for(final Entry<String, Character> entry : charItems.entrySet())
		{
			str.add("  " + ChatColor.BLUE + entry.getValue() + ChatColor.GRAY + " = " + ChatColor.WHITE + entry.getKey());
		}
		
		final int offset = str.size();
		final String[] display = new String[offset + results.size()];
		
		for(int i = 0; i < offset; i++)
		{
			display[i] = str.get(i);
		}
		
		for(int i = 0; i < results.size(); i++)
		{
			display[i + offset] = ChatColor.GREEN + " => " + ChatColor.WHITE + results.get(i).printAuto();
		}
		
		return display;
	}
}